package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.lowlevel.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api.AbstractGeniAggregateManager;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.*;
import be.iminds.ilabt.jfed.lowlevel.stitching.StitchingDirector;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * User: twalcari
 * Date: 1/27/2016
 * Time: 10:59
 */
interface AllocationDirector {

    void reportGiveUp();

    boolean isGaveUp();

    boolean areAnyActionsLeft();

    @Nonnull
    List<StitchingDirector.StitchAction> getStitchActions();

    @Nonnull
    StitchingDirector.AllocateVerdict processAllocateResult(@Nonnull StitchingDirector.StitchAction stitchAction,
                                                            @Nullable AbstractGeniAggregateManager.AggregateManagerReply reply) throws JFedException;

    void processListResourcesResult(@Nonnull Server auth, @Nullable String advertisementRspec);

    void processDeleteResult(@Nonnull Server auth) throws JFedException;

//    @Nonnull
    void/*StitchingDirector.AllocateVerdict*/ reportReadyForRetry(@Nonnull Server auth);
}
